﻿@model GoC.AppStatus.WebClient.Models.DashboardViewModel

@using static GoC.AppStatus.WebClient.Tools;

@{
    var UserID = Context.User.FindFirst(GoC.AppStatus.WebClient.Configs.CustomClaimTypes.Identifier);
}

<h1>@Localizer["Dashboard"]</h1>
<p class="lead">@Localizer["Hello and Welcome! We have you registered as {0}.", Context.User.FindFirst(System.Security.Claims.ClaimTypes.Name).Value]</p>

<p>
    @Localizer["AppStatus is an application service to track the status of any other application, controlled by a web-application front end."]
    @Localizer["Anyone with a '@hrsdc - rhdcc.gc.ca' email can register an account to use the service."]
    @Localizer["Any user could then subscribe to any registered service."]
    @Localizer["By subscribing the user will receive an email notice any time the service is found to be non-responsive."]
</p>

<a id="testEmail"
   class="btn btn-info"
   asp-action="TestEmail"
   asp-controller="Home">
    @Localizer["Test Email Notification"]
</a>

@* Modal for TestEmail confirmation *@
<section id="testEmailConfirmation"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div class="modal-body">
        @Localizer["An email was sent to {0}.", @Context.User.FindFirst(System.Security.Claims.ClaimTypes.Email).Value]
    </div>
</section>

<h2>@Localizer["Registered Services"]</h2>

<!--Register Service button-->
<div class="btn-group mrgn-bttm-lg">
    <a class="btn btn-info"
       type="button"
       asp-action="Register"
       asp-controller="Services">
        @Localizer["Register a new Service"]
    </a>
</div>

<!--List of Services-->
<ul class="list-group">
    @{ 
        var httpClient = new System.Net.Http.HttpClient();
        GoC.AppStatus.CheckService.Utilities.ServiceTester tester = new GoC.AppStatus.CheckService.Utilities.ServiceTester(httpClient);
    }
    @foreach (var service in Model.AllServices) // AllServices: services created by the user
    {
        if (!service.DisabledDatetime.ToString().StartsWith("0001")) // service is removed
        {
            continue;
        }

        <li id="li_@service.Id" class="list-group-item">
            <div class="row">
                <div class="col-md-6">
                    <h3 class="list-group-item-heading">
                        @{
                            var currentStatusCode = tester.GetStatusCode(new Uri(service.Url.ToString()));
                            if (tester.IsStatusCodeValid(currentStatusCode))
                            {
                                <span style="color:limegreen; vertical-align: top;" class="glyphicon glyphicon-ok-sign"></span>
                            }
                            else
                            {
                                <span style="color:red; vertical-align: top;" class="glyphicon glyphicon-remove-sign"></span>
                            }
                        }
                        <strong>@service.Name</strong>
                        @if (service.envId != 0)
                        {
                            <span style="font-size: 80%; font-weight:normal; color: white; background: #@service.envColour;">&nbsp;@service.envTitle&nbsp;</span>
                        }
                        @if (service.Url.ToString().StartsWith("https", StringComparison.InvariantCultureIgnoreCase))
                        {
                            int certExpiryDays = service.CertExpiryDays;
                            string backColor = "";
                            string fontColor = "";
                            var sslMessage = Localizer[""];
                            if (certExpiryDays != int.MaxValue)
                            {

                                if (certExpiryDays <= 0)
                                {
                                    backColor = "red";
                                    fontColor = "white";
                                    sslMessage = Localizer["The SSL certificate expired {0} day(s) ago.", Math.Abs(certExpiryDays)];
                                }
                                else if (certExpiryDays <= 7)
                                {
                                    backColor = "orange";
                                    fontColor = "white";
                                    sslMessage = Localizer["The SSL certificate will expire in {0} day(s).", certExpiryDays];
                                }
                                else if (certExpiryDays <= 30)
                                {
                                    backColor = "yellow";
                                    fontColor = "gray";
                                    sslMessage = Localizer["The SSL certificate will expire in {0} day(s).", certExpiryDays];
                                }
                                <span style="padding:5px; font-size: 50%; vertical-align: middle; font-weight: normal; color: @fontColor; background-color: @backColor; ">@sslMessage</span>
                            }
                        }
                    </h3>

                    <p class="list-group-item-text">
                        <a href="@service.Url"
                           target="_blank">
                            @service.Url
                        </a>
                    </p>
                </div>

                <div class="col-md-6">
                    <div class="btn-group pull-right">
                        <a class="btn btn-default"
                           type="button"
                           asp-action="Edit"
                           asp-route-id="@service.Id.ToString()"
                           asp-controller="Services">
                            @Localizer["Edit"]
                        </a>

                        <button id="btn_subscribe_@service.Id"
                                style="@(service.Subscribed ? "display:none" : "display:block")"
                                value="@service.Id"
                                class="btn btn-default subscribe">
                            @Localizer["Subscribe"]
                        </button>

                        <button id="btn_unsubscribe_@service.Id"
                                style="@(service.Subscribed ? "display:block" : "display:none")"
                                value="@service.Id"
                                class="btn btn-default unsubscribe">
                            @Localizer["Unsubscribe"]
                        </button>

                        <button value="@service.Id,@service.Name"
                                class="btn btn-default remove">
                            @Localizer["Remove"]
                        </button>
                    </div>
                </div>
            </div>
        </li>
    }
</ul>

@* Modal for confirmation of removing service *@
<section id="removeServiceConfirmation"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div class="modal-body">
        <p id="removeServiceConfirmationMsg"></p>
        <button id="btnremoveServiceConfirmation" class="btn btn-default popup-modal-dismiss" onclick="RemoveService(this.val);">
            @Localizer["Yes"]
        </button>
        <button class="btn btn-default popup-modal-dismiss">
            @Localizer["No"]
        </button>
    </div>
</section>

@* Modal for result of subscribing/removing service (success or error) *@
<section id="subscribedRemovedService"
         class="mfp-hide modal-dialog modal-content overlay-def">
    <div id="divSubscribedRemovedService" class="modal-body">
    </div>
</section>

@section CustomScripts {
    <script>

        //Ajax function to call TestEmail without leaving the page
        $("#testEmail").click(function (e) {
            e.preventDefault();
            $.ajax({
                url: "Home/TestEmail",
                success: function () {
                    $(document).trigger("open.wb-lbx", [[{ src: "#testEmailConfirmation", type: "inline" }]]);
                }
            });
        });

        // Ajax function to call Subscribe method:
        $(".subscribe").on('click', function () {
            SubscribeUnsubscribe($(this).val(), true);
        });

        // Ajax function to call Unsubscribe method:
        $(".unsubscribe").on('click', function () {
            SubscribeUnsubscribe($(this).val(), false);
        });

        // function to subscribe/unsubscribe service:
        function SubscribeUnsubscribe(serviceId, subscribe) {
            var data = { "serviceId": serviceId };
            if (subscribe) var url = "/Services/Subscribe"; else var url = "/Services/Unsubscribe";
            $.ajax({
                url: url,
                data: data,
                success: function (result) {
                    if (result) {
                        if (subscribe) {
                            document.getElementById('btn_subscribe_' + serviceId).style.display = "none";
                            document.getElementById('btn_unsubscribe_' + serviceId).style.display = "block";
                            var msg = '@Localizer["Service has been subscribed."]';
                        }
                        else {
                            document.getElementById('btn_subscribe_' + serviceId).style.display = "block";
                            document.getElementById('btn_unsubscribe_' + serviceId).style.display = "none";
                            var msg = '@Localizer["Service has been unsubscribed."]';
                        }
                    }
                    else {
                        if (subscribe) var msg = '@Localizer["An error occurred during service subscribing!"]';
                        else msg = '@Localizer["An error occurred during service unsubscribing!"]';
                    }
                    document.getElementById("divSubscribedRemovedService").innerHTML = msg;
                    $(document).trigger("open.wb-lbx", [[{ src: "#subscribedRemovedService", type: "inline" }]]);
                }
            });
        }

        // Ajax call to remove service (confirmation required):
        $(".remove").on('click', function () {
            var array = $(this).val().split(',');
            var id = array[0];
            var name = array[1];
            var msg = '@Localizer["Are you sure you want to delete the service named"]' + ' "' + name + '"?<br /><br />';
            msg += '@Localizer["Warning: this action can not be undone!"]' + '<br /><br />';
            document.getElementById("removeServiceConfirmationMsg").innerHTML = msg;
            document.getElementById("btnremoveServiceConfirmation").val = id;
            $(document).trigger("open.wb-lbx", [[{ src: "#removeServiceConfirmation", type: "inline" }]]);
            return;
        });

        // Ajax call to remove service (after user has confirmed removing):
        function RemoveService(id) {
            var data = { "id": id };
            $.ajax({
                url: "/Services/Remove",
                data: data,
                success: function (result) {
                    if (result) {
                        document.getElementById('li_' + id).style.display = "none";
                        msg = '@Localizer["Service has been removed."]';
                    }
                    else {
                        msg = '@Localizer["An error occurred during service removing!"]';
                    }
                    document.getElementById("divSubscribedRemovedService").innerHTML = msg;
                    $(document).trigger("open.wb-lbx", [[{ src: "#subscribedRemovedService", type: "inline" }]]);
                }
            });
        }
    </script>
}
